=== executable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(testapp LANGUAGES CXX)

add_executable(testapp app.cpp)
