=== static/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(testlib LANGUAGES CXX)

add_library(testlib STATIC lib.cpp)
